const BASE_TITLE = '｜クライアント証明書管理';

function process(event){
    var method = $(event.target).attr('name');

    process_done(method);
}

function process_done(method){
    var ret = {result:true, funcData:''};

    var ajaxParam = null;
    var nextFunc = null;

    switch(method){
        case 'login':
            ajaxParam = $(':input').serializeArray();   // Ajaxパラメータ設定
            nextFunc = function(method, data){ return process_done('list'); };  // リスト表示←成功時の処理
            break;

        case 'list':
            ajaxParam = $(':input').serializeArray();
            nextFunc = function(method, data){ return loadHtml('list', data); };
            break;

        case 'edit':
            ajaxParam = $('#table :checked').serializeArray();
            nextFunc = function(method, data){ return loadHtml('edit', data); };
            break;

        case 'delete':
            // ←削除確認をココに
            ajaxParam = $('#table :checked').serializeArray();
            nextFunc = function(method, data){ return process_done('list'); };  // リスト表示
            break;

        case 'add':
            ajaxParam = new Array();    // Dummy data;
            nextFunc = function(method, data){ return loadHtml('add', data); };
            break;

        case 'add_done':
            // ←入力チェックをココに
            ajaxParam = $(':input').serializeArray();            // Ajaxパラメータ設定
            nextFunc = function(method, data){ return process_done('list'); };  // リスト表示
            break;

        case 'add_cancel':
            nextFunc = function(method, data){ return process_done('list'); };  // リスト表示
            break;

        default:
            break;
    }

    var ret_Ajax = callAjax(method, ajaxParam, nextFunc);
    if (!ret_Ajax.result) {

        // Ajaxエラー処理
        $('#result').append(ret_Ajax.funcData);

        ret = {result:false, funcData:ret_Ajax.funcData};
    }
    
    delete ajaxParam;
    delete nextFunc;

    return ret;
}

function createView(method, data){

    switch(method){
        case 'login':
            break;

        case 'list':
            // リスト作成
            var j_data = $.parseJSON(data);
            var row = null;
            var td = null;
            var key = null;
            $.each(j_data,function(index,value){
                row = document.createElement('tr');
                for(key in value){
                    if (value.hasOwnProperty(key)) {
                        td = document.createElement('td');
                        if(key === 'id'){
                            td.innerHTML = '<input type="checkbox" name="param1" value="' + value[key] + '">';
                        }
                        td.innerHTML += value[key];
                        row.appendChild(td);
                    }
                }
                $('#table').append(row);
            });
            $.getScript("js/list.js");
            break;

        case 'edit':
            break;

        case 'delete':
            break;

        case 'add':
            $.getScript("js/add.js");
            break;

        case 'add_done':
            break;

        default:
            break;
    }

    // デバッグエリア削除
    //$('.debug').remove();

}

/* htmlのload */
function loadHtml(method, data){
    var ret = {result:true, funcData:''};

    var p = { method:method, data:data };

    $('body').load(
        method + '.html #wrap',
        p,
        function(response, status, xhr) {
            if (status === 'error') {
                var msg = 'load(' + method +'.html)リクエストは失敗しました。: ';
                ret = {result:false, funcData:msg + xhr.status + ' ' + xhr.statusText};
            }else{
                createView(p.method, p.data);
            }
        }
    );
    
    return ret;
}

/* Ajaxでphp関数を呼び出す */
/* 後続関数があれば実行    */
function callAjax(method, param, nextFunc) {
    var ret = {result:true, funcData:''};

    if(param != null){
        param.push({name:'method', value:method});
        $.ajax({
            dataType: 'json',
            data: param,
            url: 'php/do.php',
            async: false,
            success: function(ajaxData) {
                if(ajaxData.result.toLowerCase() === 'success') {
                    if(nextFunc!==null){
                        var ret_func = nextFunc(method, ajaxData.resData);
                        if(ret_func.result){
                            ret = {result:true, funcData:ret_func.funcData};
                        }else{
                            ret = {result:false, funcData:ret_func.funcData};
                        }
                    }
                }
                else{
                    ret = {result:false, funcData:ajaxData.resData};
                }
            },
            error: function(ajaxData) {
                ret = {result:false, funcData:ajaxData.status + ' ' + ajaxData.responseText};
            }
        });
    }else{
        if(nextFunc!==null){
            var ret_func = nextFunc(method, param);
            if(ret_func.result){
                ret = {result:true, funcData:ret_func.funcData};
            }else{
                ret = {result:false, funcData:ret_func.funcData};
            }
        }
    }
    
    return ret;
}

function createTitle(str){
    return str + BASE_TITLE;
}
