function process(event){
    var method = $(event.target).attr('name');

    process_done(method);
}

function process_done(method){
    var param = null;
    var ret = null;
    
    var func = null;

    switch(method){
        case 'login':
            param = $(':input').serializeArray();                       // Ajaxパラメータ設定
            func = function(method, data){ process_done('list'); }    // 成功時の処理

            /* ログイン処理
            ret = callAjax(method, $(':input').serializeArray());
            if (ret.result) {
                process_done('list');        // ログイン成功なら一覧取得
            }
            else{
                $('#result').append(ret.data);  // ログイン失敗時はエラー処理
            }
            */
            
            break;

        case 'list':
            param = $(':input').serializeArray();            // Ajaxパラメータ設定
            func = function(method, data){ createListView(data); }  // 成功時の処理

            /*
            ret = callAjax(method, $(':input').serializeArray());
            if (ret.result) {
                // データ取得成功ならリスト表示
                createListView(ret.data);
            }else{
                $('#result').append(ret.data);
            }
            */
            
            break;

        case 'edit':
            param = $('#table :checked').serializeArray();
            break;

        case 'delete':
            param = $('#table :checked').serializeArray();
            break;

        case 'add':
            param = '';
            func = function(method, data){ createAddView(data); }
            break;

        case 'add_done':
            param = $(':input').serializeArray();            // Ajaxパラメータ設定
            func = function(method, data){ createListView(data); }  // 成功時の処理
            break;

        default:
            break;
    }

    ret = callAjax(method, param);
    if (!ret.result) {
        $('#result').append(ret.data);  // Ajaxエラー処理
        return;
    }

    if(func != null){
        func(method, ret.data);
        func = null;
    }

    delete param;
    delete ret;
}



/* Ajaxでphp関数を呼び出す(Ajaxだが同期させている) */
function callAjax(method, param1) {
    var retVal;
    
    param1.push({name:'method', value:method});

    $.ajax({
        dataType: 'json',
        data: param1,
        url: 'php/do.php',
        async: false,
        success: function(data) {
            if(data.result.toLowerCase() === 'success') {
                retVal = {result:true, data:data.contents};
            }
            else{
                retVal = {result:false, data:data.contents};
            }
        },
        error: function(data) {
            retVal = {result:false, data:data.contents};
        }
    });
    
    delete param1;
    
    return retVal;
}

function createListView(data) {
    $('#wrap').remove();
    $('body').load(
        'list.html #wrap',
        data,
        function(response, status, xhr) {
            if (status == 'error') {
                // loadエラー
                var msg = 'load(/html/list.html)リクエストは失敗しました。: ';
                $('#result').append(msg + xhr.status + ' ' + xhr.statusText);
            }else{
                // リスト作成
                var j_data = $.parseJSON(data);
            
                var row = null;
                var td = null;
                var key = null;
            
                $.each(j_data,function(index,value){
                    row = document.createElement('tr');

                    for(key in value){
                        if (value.hasOwnProperty(key)) {
                            td = document.createElement('td');
                            
                            if(key == 'id'){
                                td.innerHTML = '<input type="checkbox" name="param1" value="' + value[key] + '">';
                            }

                            td.innerHTML += value[key];
                            row.appendChild(td);
                        }
                    }

                    
                    $('#table').append(row);
                });
                
                
                addEvent('list');   // イベント追加
                
                // デバッグエリア削除
//                $('.debug').remove();
            }
        }
    );
}

function createAddView() {
    $('#wrap').remove();
    $('body').load(
        'add.html #wrap',
        data,
        function(response, status, xhr) {
            if (status == 'error') {
                // loadエラー
                var msg = 'load(html/list.html)リクエストは失敗しました。: ';
                $('#result').append(msg + xhr.status + ' ' + xhr.statusText);
            }else{
                // イベント追加
                addEvent('add');
            }
        }
    );
}




/* イベント設定 */
function addEvent(method) {
    switch(method){
        case 'login':
            $('#login').click( process );
            break;

        case 'list':
            $('#editbtn').click( process );
            $('#deletebtn').click( process );
            $('#addbtn').click( process );

            $('#table :checkbox').click(function() {
                if($('#table :checked').length > 1) {
                    $('#editbtn').attr('disabled', true);
                } else {
                    $('#editbtn').attr('disabled', false);
                }
            });
            break;

        case 'edit':
            break;

        case 'delete':
            break;

        case 'add':
            $('#add_done').click( process );
            break;

        default:
            break;
    }
}

function updateTitle(method) {
    switch(method){
        case 'login':
            break;
        
        case 'list':
            break;
        
        case 'edit':
            break;
        
        case 'delete':
            break;
        
        case 'add':
            break;
        
        default:
            break;
    }
}
