const BASE_TITLE = '｜クライアント証明書管理';

function process(event){
    var method = $(event.target).attr('name');

    process_done(method);
}

function process_done(method){
    var ret = {result:true, funcData:''};

    var ajaxParam = {param1:''};                // Dummy data;
    var nextFunc = function(method, data){};   // Dummy function;

    switch(method){
        case 'login':
            ajaxParam = $(':input').serializeArray();   // Ajaxパラメータ設定
            nextFunc = function(method, data){ return process_done('list'); };  // リスト表示←成功時の処理
            break;

        case 'list':
            ajaxParam = $(':input').serializeArray();
            nextFunc = function(method, data){ return loadHtml('list.html', 'list', data); };
            break;

        case 'edit':
            ajaxParam = $('#table :checked').serializeArray();
            break;

        case 'delete':
            ajaxParam = $('#table :checked').serializeArray();
            break;

        case 'add':
            nextFunc = function(method, data){ return loadHtml('add.html', 'add', data); };
            break;

        case 'add_done':
            ajaxParam = $(':input').serializeArray();            // Ajaxパラメータ設定
            nextFunc = function(method, data){ return process_done('list'); };  // リスト表示
            break;

        case 'add_cancel':
            nextFunc = function(method, data){ return process_done('list'); };  // リスト表示
            break;

        default:
            break;
    }

    var ret_Ajax = callAjax(method, ajaxParam, nextFunc);
    if (!ret_Ajax.result) {

        // Ajaxエラー処理
        $('#result').append(ret_Ajax.data);

        ret = {result:false, funcData:ret_Ajax.data};
    }
    
    return ret;
    
/*
    if(nextFunc != null){
        nextFunc(method, ret.data);
        nextFunc = null;
    }
*/
/*
    delete ajaxParam;
    delete ret;
*/
}

function createView(method, data){

    switch(method){
        case 'login':
            break;

        case 'list':
            // タイトル変更
            document.title = createTitle('一覧');
            // リスト作成
            var j_data = $.parseJSON(data);
            var row = null;
            var td = null;
            var key = null;
            $.each(j_data,function(index,value){
                row = document.createElement('tr');
                for(key in value){
                    if (value.hasOwnProperty(key)) {
                        td = document.createElement('td');
                        if(key === 'id'){
                            td.innerHTML = '<input type="checkbox" name="param1" value="' + value[key] + '">';
                        }
                        td.innerHTML += value[key];
                        row.appendChild(td);
                    }
                }
                $('#table').append(row);
            });
            // イベント追加
            $('#editbtn').click( process );     // 編集ボタン
            $('#deletebtn').click( process );   // 削除ボタン
            $('#addbtn').click( process );      // 追加ボタン
            $('#table :checkbox').click(function() {    // 2チェック以上は編集ボタン押下不可
                if($('#table :checked').length > 1) {
                    $('#editbtn').attr('disabled', true);
                } else {
                    $('#editbtn').attr('disabled', false);
                }
            });
            break;

        case 'edit':
            break;

        case 'delete':
            break;

        case 'add':
            // タイトル変更
            document.title = createTitle('追加');
            // イベント追加
            $('#add_done').click( process );
            $('#add_cancel').click( process );
            break;

        case 'add_done':
            break;

        default:
            break;
    }

    // デバッグエリア削除
    //$('.debug').remove();

}

/* htmlのload */
function loadHtml(l_file, l_method, l_data){
    var ret = {result:true, funcData:''};

    var p = { method:l_method, data:l_data };

    $('body').load(
        l_file + ' #wrap',
        p,
        function(response, status, xhr) {
            if (status === 'error') {
                var msg = 'load(' + l_file +')リクエストは失敗しました。: ';
                ret = {result:false, funcData:msg + xhr.status + ' ' + xhr.statusText};
            }else{
                createView(p.method, p.data);
            }
        }
    );
    
    return ret;
}

/* Ajaxでphp関数を呼び出す      */
function callAjax(method, param, func) {
    var ret = {result:true, funcData:''};

    if(param != null){
        param.push({name:'method', value:method});
        $.ajax({
            dataType: 'json',
            data: param,
            url: 'php/do.php',
            async: false,
            success: function(ajaxData) {
                if(ajaxData.result.toLowerCase() === 'success') {
                    var ret_func = func(method, ajaxData.resData);
                    if(ret_func.result){
                        ret = {result:true, funcData:ret_func.funcData};
                    }else{
                        ret = {result:false, funcData:ret_func.funcData};
                    }
                    
                }
                else{
                    ret = {result:false, funcData:ajaxData.resData};
                }
            },
            error: function(ajaxData) {
                ret = {result:false, funcData:ajaxData.resData};
            }
        });
    }else{
        var ret_func = func(method, param);
        if(ret_func.result){
            ret = {result:true, funcData:ret_func.funcData};
        }else{
            ret = {result:false, funcData:ret_func.funcData};
        }
    }
    
    return ret;
}
/*
function following(func, method, data){
    var retVal;
    var ret = func(method, data);
    if(ret.result){
        retVal = {result:true, data:ret.resData};
    }else{
        retVal = {result:false, data:ret.resData};
    }
}
*/

function createTitle(str){
    return str + BASE_TITLE;
}

/* 一覧表示処理　引数：表示データ(JSON形式) *
function createListView(data) {
    $('#wrap').remove();
    $('body').load(
        'list.html #wrap',
        data,
        function(response, status, xhr) {
            if (status == 'error') {
                // loadエラー
                var msg = 'load(/html/list.html)リクエストは失敗しました。: ';
                $('#result').append(msg + xhr.status + ' ' + xhr.statusText);
            }else{
                // リスト作成
                var j_data = $.parseJSON(data);
            
                var row = null;
                var td = null;
                var key = null;
            
                $.each(j_data,function(index,value){
                    row = document.createElement('tr');

                    for(key in value){
                        if (value.hasOwnProperty(key)) {
                            td = document.createElement('td');
                            
                            if(key == 'id'){
                                td.innerHTML = '<input type="checkbox" name="param1" value="' + value[key] + '">';
                            }

                            td.innerHTML += value[key];
                            row.appendChild(td);
                        }
                    }

                    
                    $('#table').append(row);
                });
                
                
                addEvent('list');   // イベント追加
                
                // デバッグエリア削除
//                $('.debug').remove();
            }
        }
    );
}

function createAddView() {
    $('#wrap').remove();
    $('body').load(
        'add.html #wrap',
        data,
        function(response, status, xhr) {
            if (status == 'error') {
                // loadエラー
                var msg = 'load(html/list.html)リクエストは失敗しました。: ';
                $('#result').append(msg + xhr.status + ' ' + xhr.statusText);
            }else{
                // イベント追加
                addEvent('add');
            }
        }
    );
}
*/
